<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>updateUser</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <title>updateUser</title>
  </head>
  <body onload="onPageLoading()">
    <div class="container jumbotron">
      <div class="text-center mb-4">
        <h3>Chi tiết User</h3>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">First Name</label>
        </div>
        <div class="col-sm-8">
          <input
            type="text"
            class="form-control"
            placeholder="Nhập Firstname ..."
            id="input-firstname"
          />
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">Last Name</label>
        </div>
        <div class="col-sm-8">
          <input
            type="text"
            class="form-control"
            placeholder="Nhập Lastname ..."
            id="input-lastname"
          />
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">Subject</label>
        </div>
        <div class="col-sm-8">
          <input
            type="text"
            class="form-control"
            placeholder="Nhập Subject ..."
            id="input-subject"
          />
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">Country</label>
        </div>
        <div class="col-sm-8">
          <select name="country" id="select-country" class="form-control">
            <option value="VN">Việt Nam</option>
            <option value="USA">USA</option>
            <option value="AUS">Australia</option>
            <option value="CAN">Canada</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">Customer type</label>
        </div>
        <div class="col-sm-8">
          <select
            name="customertype"
            id="select-customertype"
            class="form-control"
          >
            <option value="Standard">Standard</option>
            <option value="Gold">Gold</option>
            <option value="Premium">Premium</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4">
          <label for="">Register Status</label>
        </div>
        <div class="col-sm-8">
          <select
            name="registerstatus"
            id="select-register-status"
            class="form-control"
          >
            <option value="New">New</option>
            <option value="Accepted">Accepted</option>
            <option value="Denied">Denied</option>
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-4"></div>
        <div class="col-sm-8">
          <button type="button" class="btn btn-success w-25" id="btn-update">
            Update user
          </button>
          <button type="button" class="btn btn-success w-25" id="btn-update">
            Hủy bỏ
          </button>
        </div>
      </div>
    </div>
  </body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gInputFirstName = $("#input-firstname");
    var gInputLastName = $("#input-lastname");
    var gSelectCountry = $("#select-country");
    var gInputSubject = $("#input-subject");
    var gSelectCustomerType = $("#select-customertype");
    var gSelectRegisterStatus = $("#select-register-status");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict";
      //thu thập dữ liệu từ query string
      var vId = getId();
      console.log(vId);
      callAPIGetDataUserById(vId);
    }

    $(document).ready(function () {
      $("#btn-update").on("click", function (event) {
        event.preventDefault();
        callAjaxRestApiUpdate();
      });
    });

    function getId() {
      var vUrlString = window.location.href;
      var vUrl = new URL(vUrlString);
      //get parameter
      var vId = vUrl.searchParams.get("id");
      return vId;
    }

    //hàm load user data dùng ajax
    function callAPIGetDataUserById(paramUserId) {
      "use strict";
      $.ajax({
        url:
          "http://203.171.20.210:8080/devcamp-register-java-api/users/" +
          paramUserId,
        type: "GET",
        dataType: "json",
        success: function (res) {
          console.log(res);
          showDataUserToForm(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }

    //hàm xư lý hiển thị dữ liệu lên form
    function showDataUserToForm(param) {
      "use strict";
      gInputFirstName.val(param.firstname);
      gInputLastName.val(param.lastname);
      gSelectCountry.val(param.country);
      gInputSubject.val(param.subject);
      gSelectCustomerType.val(param.customerType);
      gSelectRegisterStatus.val(param.registerStatus);
    }

    //update user info, ajax call
    function callAjaxRestApiUpdate() {
      "use strict";

      var vObjectRequestData = {
        id: "",
        firstname: "", //bạn có thể sửa các giá trị này để thử, và lại get lại data
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
        registerStatus: "",
      };
      // 1. Đọc dữ liệu
      readDataUser(vObjectRequestData);

      //2 . Kiểm tra
      var vIsCheck = validateForm(vObjectRequestData);
      if (vIsCheck) {
        //3. Gọi server  phải implement ajax put call tại đây (gọi rest API by Ajax)
        /***  ..............code của bạn ở đây ......................****/
        $.ajax({
          url:
            "http://203.171.20.210:8080/devcamp-register-java-api/users/" +
            vObjectRequestData.id,
          type: "PUT",
          contentType: "application/json",
          data: JSON.stringify(vObjectRequestData), // added data type
          success: getUserDataByIdResponseSuccess,
          error: getUserDataByIdError,
        });
      }
    }

    function readDataUser(paramUserData) {
      var vId = getId();

      paramUserData.id = vId;
      paramUserData.firstname = gInputFirstName.val();
      paramUserData.lastname = gInputLastName.val();
      paramUserData.country = gSelectCountry.val();
      paramUserData.subject = gInputSubject.val();
      paramUserData.customerType = gSelectCustomerType.val();
      paramUserData.registerStatus = gSelectRegisterStatus.val();
    }

    function validateForm(paramUserData) {
      if (paramUserData.firstname == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      if (paramUserData.lastname == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      if (paramUserData.country == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      if (paramUserData.subject == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      if (paramUserData.customerType == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      if (paramUserData.registerStatus == "") {
        alert("firstname bạn chưa nhập vào.");
        return false;
      }
      return true;
    }

    //call back function
    function getUserDataByIdResponseSuccess(responseObject) {
      console.log(responseObject);
      console.log(Object.entries(responseObject));
      alert("bạn đã update thành công! Nhấn ok sẽ trở về list form.");
      window.location.href = "task 33.20.html";
    }
    function getUserDataByIdError(ajaxContext) {
      alert(ajaxContext.responseText);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  </script>
</html>
